// Code generated by go-swagger; DO NOT EDIT.

package users

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	middleware "github.com/go-openapi/runtime/middleware"
	strfmt "github.com/go-openapi/strfmt"
	swag "github.com/go-openapi/swag"
)

// UserRequestHandlerFunc turns a function with the right signature into a user request handler
type UserRequestHandlerFunc func(UserRequestParams, *ticketboss) middleware.Responder

// Handle executing the request and returning a response
func (fn UserRequestHandlerFunc) Handle(params UserRequestParams, principal *ticketboss) middleware.Responder {
	return fn(params, principal)
}

// UserRequestHandler interface for that can handle valid user request params
type UserRequestHandler interface {
	Handle(UserRequestParams, *ticketboss) middleware.Responder
}

// NewUserRequest creates a new http.Handler for the user request operation
func NewUserRequest(ctx *middleware.Context, handler UserRequestHandler) *UserRequest {
	return &UserRequest{Context: ctx, Handler: handler}
}

/*UserRequest swagger:route POST /users Users userRequest

Create a new User.

JSON Response is provided with respective success or fail details.

*/
type UserRequest struct {
	Context *middleware.Context
	Handler UserRequestHandler
}

func (o *UserRequest) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewUserRequestParams()

	uprinc, aCtx, err := o.Context.Authorize(r, route)
	if err != nil {
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}
	if aCtx != nil {
		r = aCtx
	}
	var principal *ticketboss
	if uprinc != nil {
		principal = uprinc.(*ticketboss) // this is really a ticketboss, I promise
	}

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params, principal) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}

// UserRequestBody user request body
// swagger:model UserRequestBody
type UserRequestBody struct {

	// email
	Email string `json:"email,omitempty"`

	// img URL
	ImgURL string `json:"img_url,omitempty"`

	// name
	Name string `json:"name,omitempty"`

	// password
	Password string `json:"password,omitempty"`

	// phone
	Phone string `json:"phone,omitempty"`

	// type
	Type int64 `json:"type,omitempty"`
}

// Validate validates this user request body
func (o *UserRequestBody) Validate(formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (o *UserRequestBody) MarshalBinary() ([]byte, error) {
	if o == nil {
		return nil, nil
	}
	return swag.WriteJSON(o)
}

// UnmarshalBinary interface implementation
func (o *UserRequestBody) UnmarshalBinary(b []byte) error {
	var res UserRequestBody
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*o = res
	return nil
}
